{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}
unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, System.ComponentModel, Borland.Vcl.Db, Borland.Vcl.ADODB,
  Borland.Vcl.StdCtrls, Borland.Vcl.ADOInt, Borland.Vcl.Grids,
  Borland.Vcl.DBGrids, Borland.Vcl.ExtCtrls, Borland.Vcl.DBCtrls;

type
  TfrmDbGo = class(TForm)
    ADOConnection1: TADOConnection;
    ADOCommand1: TADOCommand;
    ADODataSet1: TADODataSet;
    ListBox1: TListBox;
    btnListCmd: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    btnOpenDataset: TButton;
    btnCloseDataset: TButton;
    ListBox2: TListBox;
    Label4: TLabel;
    Shape1: TShape;
    DBNavigator1: TDBNavigator;
    procedure btnCloseDatasetClick(Sender: TObject);
    procedure btnOpenDatasetClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnListCmdClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDbGo: TfrmDbGo;

implementation
uses System.Runtime.InteropServices;

{$R *.nfm}

function OleVarDataToVariant(OleVarData: TOleVarData): Variant;
var
  Buffer: IntPtr;
begin
  Buffer := Marshal.AllocHGlobal(Marshal.SizeOf(TypeOf(TOleVarData)));
  try
    Marshal.StructureToPtr(OleVarData, Buffer, False);
    Result := Variant(Marshal.GetObjectForNativeVariant(Buffer));
  finally
    Marshal.FreeHGlobal(Buffer);
  end;
end;

procedure TfrmDbGo.btnListCmdClick(Sender: TObject);
 var r : _Recordset; i:integer; s:string;
begin
 listbox1.Clear;
 listbox2.Clear;
 AdoConnection1.Open;
 r := ADOCommand1.Execute;
 listbox1.items.BeginUpdate;
 try
  for i:=0 to r.Fields.Count-1 do
   listbox1.Items.Append(r.Fields[i].Name);
 finally
  listbox1.items.EndUpdate;
 end;
 listbox2.Items.BeginUpdate;
 try
  while (r.EOF=false) do
   begin
    s:='';
    for i := 0 to r.Fields.Count-1 do
     begin
      if s<>'' then s:=s+', ';
      s:=s+OleVarDataToVariant(r.Fields[i].Value);
     end;
    listbox2.Items.append(s);
    r.MoveNext;
   end;
 finally
  listbox2.Items.EndUpdate;
 end;
 r.Close;
 AdoConnection1.close;
end;

procedure TfrmDbGo.FormCreate(Sender: TObject);
begin
 label3.Caption := ADOCommand1.CommandText;
end;

procedure TfrmDbGo.btnOpenDatasetClick(Sender: TObject);
begin
 ADODataSet1.Open;
end;

procedure TfrmDbGo.btnCloseDatasetClick(Sender: TObject);
begin
 ADODataSet1.Close;
end;

end.
